
--  with System;
--  with Global_Priorities;
--  with Rt_Ep_Protocol;

package body Global_Priorities.Mapping is

   function To_Global_Priority (The_Priority : System.Priority)
                               return Global_Priorities.Priority is
   begin
      return Global_Priorities.Priority (The_Priority);
   end To_Global_Priority;



   function To_Native_Priority (The_Priority : Global_Priorities.Priority)
                               return System.Priority is
   begin
      return System.Priority (The_Priority);
   end To_Native_Priority;



   function To_Rt_Ep_Priority (The_Priority : Global_Priorities.Priority)
                              return Rt_Ep_Protocol.RT_EP_Priority is
   begin
      return Rt_Ep_Protocol.RT_EP_Priority (The_Priority);
   end To_Rt_Ep_Priority;



   function To_Local_Protocol_Priority (The_Priority :
                                          Global_Priorities.Priority)
                            return Local_Protocol.Local_Protocol_Priority is
   begin
      return Local_Protocol.Local_Protocol_Priority (The_Priority);
   end To_Local_Protocol_Priority;

end Global_Priorities.Mapping;


