--  Implementacion del protocolo Local
with Ada.Streams;  use Ada.Streams;
--  with System.Garlic.Streams; use System.Garlic.Streams;
package Local_Protocol is

   Max_Info_Size : constant := 1492;

   subtype Local_Protocol_Priority is Natural range 1 .. 32;
--   type Stream_Element_Access is access Ada.Streams.Stream_Element_Array;

   subtype Mi_Data is Stream_Element_Array (1 .. 1492);


   function Init_Local_Protocol (Prio_Ceiling : Integer) return Integer;


   function Is_Initialized return Boolean;


   procedure Init_Mutex_Sem;


   --   generic
   --        type Data_Type is private;
   --   procedure Generic_Send_Info
   procedure Send_Info
     (Destination_Address : in Integer;
      Channel_ID : in Integer;
      --      Data : in Data_Type;
      --  Data : in Mi_Data;
      Data : access Ada.Streams.Stream_Element_Array;
      --      Data : in Stream_Element_Access;
      --  access Stream_Element_Array;
      Size : in Integer;
      Data_Priority : in Integer);


   --   generic
   --        type Data_Type is private;
   --   procedure Generic_Recv_Info
   procedure Recv_Info
     (Source_Address : in Integer;
      Channel_ID : in Integer;
      --      Data : out Data_Type;
      --  Data : out Mi_Data;
      Data : access Ada.Streams.Stream_Element_Array;
      --      Data : out Stream_Element_Access;
      --   access Stream_Element_Array;
      Size : out Integer;
      Data_Priority : out Integer);

end Local_Protocol;
