
with Global_Priorities;
with RPC_Attributes;

package body  RPC_Priorities is

   procedure Set (RPC_Handler : in Global_Priorities.Priority) is
      Attribute : Global_Priorities.RPC_Priorities;
   begin
      Attribute := RPC_Attributes.Value;
      Attribute.RPC_Handler := RPC_Handler;
      RPC_Attributes.Set_Value (Attribute);
   end Set;


   procedure Set (RPC_Handler,
                  Outgoing_Message : in Global_Priorities.Priority) is
      Attribute : Global_Priorities.RPC_Priorities;
   begin
      Attribute := RPC_Attributes.Value;
      Attribute.RPC_Handler := RPC_Handler;
      Attribute.Outgoing_Message := Outgoing_Message;
      RPC_Attributes.Set_Value (Attribute);
   end Set;


   procedure Set (RPC_Handler,
                  Outgoing_Message,
                  Incoming_Message : in Global_Priorities.Priority) is
      Attribute : Global_Priorities.RPC_Priorities;
   begin
      Attribute := RPC_Attributes.Value;
      Attribute.RPC_Handler := RPC_Handler;
      Attribute.Outgoing_Message := Outgoing_Message;
      Attribute.Incoming_Message := Incoming_Message;
      RPC_Attributes.Set_Value (Attribute);
   end Set;

   procedure Get (RPC_Handler,
                  Outgoing_Message,
                  Incoming_Message : out Global_Priorities.Priority) is
      Attribute : Global_Priorities.RPC_Priorities;
   begin
      Attribute := RPC_Attributes.Value;
      RPC_Handler := Attribute.RPC_Handler;
      Outgoing_Message := Attribute.Outgoing_Message;
      Incoming_Message := Attribute.Incoming_Message;
   end Get;


end RPC_Priorities;
