#include <net/osdep.h>
#include <drivers/eth_ioctl.h>
#include <stdio.h>
#include <stdlib.h>
#include <debug_marte.h> // For Debugging
#include <unistd.h>
#include <net/if_ether.h>
#include <fcntl.h>

#include <time.h>

typedef   struct {
  struct ethhdr eth_header;
  char data[1500];
  } eth_frame;

int main(){

  //  jl--------------------------
  struct timespec ts = {0,330000000};
  struct timespec ts2;
 //  jl--------------------------



  int i,j;
  int file_descriptor;
  eth_frame eth_data, eth_data_rx;

  //char dest_addr[6];
  //  unsigned int protocol=0x1000;
  char data[30]="Hola Chema, como estas?\0";
  int data_len=24; 
  unsigned short protocol;
  // For Debugging
  //   init_serial_communication_with_gdb (SERIAL_PORT_1);
  // set_break_point_here;

#ifdef STATION_SLAVE
/* BTMMMI -> Mandos. */
//# Target Mandos
// hardware ethernet 00:08:9B:80:05:B2;
// dest:  hardware ethernet 00:08:9B:80:09:60;
//   eth_data.eth_header.h_dest ={0x00,0x08,0x9B,0x80,0x09,0x60};
   eth_data.eth_header.h_dest[0] = 0x00;
   eth_data.eth_header.h_dest[1] = 0x02;
   eth_data.eth_header.h_dest[2] = 0xB3;
   eth_data.eth_header.h_dest[3] = 0xD1; 
   eth_data.eth_header.h_dest[4] = 0x30;
   eth_data.eth_header.h_dest[5] = 0xEC; 
#endif

#ifdef STATION_MASTER

/* BTMCONT -> Controlador. */
// # Target controlador del robot
// hardware ethernet 00:08:9B:80:09:60;
// dest:   hardware ethernet 00:08:9B:80:05:B2;
   eth_data.eth_header.h_dest[0] = 0x00;
   eth_data.eth_header.h_dest[1] = 0x02;
   eth_data.eth_header.h_dest[2] = 0xB3;
   eth_data.eth_header.h_dest[3] = 0xD1; 
   eth_data.eth_header.h_dest[4] = 0x34;
   eth_data.eth_header.h_dest[5] = 0xBF; 
#endif
   
  eth_data.eth_header.h_proto=htons(0x1000);

  memcpy( eth_data.data, data ,data_len);

  printf("\n\n\nTesting Ethernet card...\n");
  printf("\nRunning eth_probe....\n");


  data_len += ETH_HLEN;
  file_descriptor=open("/dev/eth0",O_RDWR);
  printf("End open function: %d\n", file_descriptor);

  if(ioctl(file_descriptor, ETH_HWADDR , eth_data.eth_header.h_source) < 0){
    perror("function ioctl: ");
  }
  protocol=0x1000;
  ioctl(file_descriptor,SET_PROTOCOL_FILTER, &protocol);
  
  eth_printf("Current MAC ADDR: %!\n", eth_data.eth_header.h_source);

/*   sleep(100); */
  printf("End transmiting\n");
  printf("sleeping\n");
  sleep(2);
  i=1;
  memset(&eth_data,sizeof(eth_data),0);


  for(;;){

#ifdef STATION_MASTER
  printf(" %d: Transmiting: %s\n",i,data);
  if( (write(file_descriptor, &eth_data, data_len ))<0 ){
    perror("Funcion write: ");

  }
    printf("Packet %d - Frame Length: %d, Protocol: %x \n",
	   i,data_len,ntohs(eth_data.eth_header.h_proto));
    eth_printf("Source Address: %! : ",eth_data.eth_header.h_source);
    eth_printf("Destination Address: %! : \n",eth_data.eth_header.h_dest);
  printf("Ready to send another frame....<press any key> \n");
  //  nanosleep (&ts,&ts2);  //jl
  j=getchar();

#endif
#ifdef STATION_SLAVE

    if((data_len=read(file_descriptor, &eth_data_rx, ETH_FRAME_LEN)) < 0 ){
      perror("funcion read: ");
    }

  
    //    if((i % 1000)== 0){ // jl
      printf("Packet %d - Frame Length: %d, Protocol: %x \n",
	     i,data_len,ntohs(eth_data_rx.eth_header.h_proto));
      eth_printf("Source Address: %! : ",eth_data_rx.eth_header.h_source);
      eth_printf("Destination Address: %! : \n",eth_data_rx.eth_header.h_dest);

      printf("Info: %s\n",eth_data.data);
      //    }  // jl
#endif

    //eth_data.eth_header.h_dest[0]=0x00;
    //eth_data.eth_header.h_dest[1]=0x02;
    //eth_data.eth_header.h_dest[2]=0xB3;
    //eth_data.eth_header.h_dest[3]=0xBE;
    //eth_data.eth_header.h_dest[4]=0x34;
    //eth_data.eth_header.h_dest[5]=0x52;

    i++;

  }//end for
  close(file_descriptor);
  return 0;

}
