-- ejemplo1
with Ada.Text_IO; use Ada.Text_IO;
with Calculadora;
with Imprime_Remoto;
with Prote;
with RPC_Priorities;
procedure Menu is
   Resultado_Suma : Integer := 20;
   Resultado_Resta : Integer := 20;
   Permite_Resta : Boolean := False;
   Permite_Suma : Boolean := False;

   task type Type_Obrera_Suma;
   task body Type_Obrera_Suma is
      Op1 : Integer := 20;
      Op2 : Integer := 20;
   begin
      RPC_Priorities.Set (20,10,12);
      delay (2.0);
      Put_Line ("Tarea_Suma");
      loop
         if Permite_Suma then
            Prote.P_Lee_Operandos (Op1, Op2);
            Resultado_Suma := Calculadora.Sumar (Op1, Op2);
--            Put ("--Suma:: ");
            Imprime_Remoto.Print (Resultado_Suma);
         end if;
         delay (0.25);
      end loop;
   exception when others =>
      loop
         Put_Line ("Excepcion en SUMA");
      end loop;
   end Type_Obrera_Suma;


   task type Type_Obrera_Resta;
   task body Type_Obrera_Resta is
      Op1 : Integer := 20;
      Op2 : Integer := 20;
   begin
      RPC_Priorities.Set (21,11,13);
      delay (2.0);
      Put_Line ("Tarea_Resta");
      loop
         if Permite_Resta then
            Prote.P_Lee_Operandos (Op1, Op2);
            Resultado_Resta := Calculadora.Restar (Op1, Op2);
--            Put (">>Resta::");
            Imprime_Remoto.Print (Resultado_Resta);
         end if;
         delay (0.25);
      end loop;
   exception when others =>
      loop
         Put_Line ("Excepcion en RESTA");
      end loop;
   end Type_Obrera_Resta;



   Obrera1 : Type_Obrera_Suma;
   Obrera2 : Type_Obrera_Resta;

   Opp1, Opp2 : Integer := 0;
   S_Leido : String (1 .. 3);
   N_Leido : Integer := 0;
begin
   loop
      New_Line;
      New_Line;
      New_Line;
      New_Line;
      Put_Line ("********************");
      Put_Line ("***** MENU *********");
      Put_Line ("********************");
      Put_Line ("1- Sumar (por defecto 2 + 1)");
      Put_Line ("2- Restar (por defecto 2 - 1)");
      Put_Line ("3- Cambiar operandos");
      Put_Line ("4- Para de Sumar");
      Put_Line ("5- Para de Restar");

      Get_Line (S_Leido ,N_Leido);
      case Integer'Value (S_Leido(1 .. 1)) is
         when 1 =>
            Put_Line ("Opcion Elegida : 1");
--            Prote.P_Permite_Suma;
            Permite_Suma := True;
         when 2 =>
            Put_Line ("Opcion Elegida : 2");
--            Prote.P_Permite_Resta;
            Permite_Resta := True;
         when 3 =>
            Put_Line ("Opcion Elegida : 3");
            Put_Line ("  Inserte op1::");
            Get_Line (S_Leido ,N_Leido);
            Opp1 := Integer'Value (S_Leido(1 .. 1));
            Put_Line ("  Inserte op2::");
            Get_Line (S_Leido ,N_Leido);
            Opp2 := Integer'Value (S_Leido(1 .. 1));
            Prote.P_Fija_Operandos (Opp1, Opp2);
         when 4 =>
            Put_Line ("Opcion Elegida : 4");
--            Prote.P_Para_Suma;
            Permite_Suma := False;
         when 5 =>
            Put_Line ("Opcion Elegida : 5");
--            Prote.P_Para_Resta;
            Permite_Resta := False;
       when others =>
            Put_Line ("Opcion Elegida : XXXX");
      end case;

   end loop;


end Menu;
