/*----------------------------------------------------------------------------
 *-------------------------      M a R T E   O S      ------------------------
 *----------------------------------------------------------------------------
 *                                                             V1.29i Nov 2003
 *
 *                         'd e m o _ d r i v e r _ c'
 *
 *                                      C
 *
 *  File 'demo_driver_c.c'                                  by Fguerreira and
 *                                                             MAR.
 *
 *  A demostration C-driver. Just to show how drivers works in MaRTE
 *  OS. You can test this driver with program 'uses_demo_driver_c.c'
 *  in the 'examples/drivers/' directory.
 *
 *
 *  ----------------------------------------------------------------------
 *   Copyright (C) 2003   Universidad de Cantabria, SPAIN
 *
 *   MaRTE OS web page: http://marte.unican.es
 *   Contact Addresses: Mario Aldea Rivas          aldeam@ctr.unican.es
 *                      Michael Gonzlez Harbour      mgh@ctr.unican.es
 *
 *  MaRTE OS  is free software; you can  redistribute it and/or  modify it
 *  under the terms of the GNU General Public License  as published by the
 *  Free Software Foundation;  either  version 2, or (at  your option) any
 *  later version.
 *
 *  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
 *  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
 *  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
 *  General Public License for more details.
 *
 *  You should have received  a  copy of  the  GNU General Public  License
 *  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
 *  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
 *  02111-1307, USA.
 *
 *  As a  special exception, if you  link this  unit  with other  files to
 *  produce an   executable,   this unit  does  not  by  itself cause  the
 *  resulting executable to be covered by the  GNU General Public License.
 *  This exception does  not however invalidate  any other reasons why the
 *  executable file might be covered by the GNU Public License.
 *
 *---------------------------------------------------------------------------*/
//////////////////////////////////////////////////
// Siempre devuelvo la misma direccion en el mmap
unsigned long direccion_vuelta_mmap_shared_memory;
int Primero = 1;
/////////////////////////////////////////////////
#include <stdlib.h>

extern void *mmap (void *addr, size_t len, int prot, int flags, int fd,
		   off_t offset)
{
  //  unsigned long direccion_vuelta;

  if (Primero == 1) {
    printf("Entro malloc::");
    direccion_vuelta_mmap_shared_memory = malloc (len);
    Primero = 0;
  }
  printf ("mmap -> (len::%d) ", len);
  printf ("direccion_vuelta %ld\n", direccion_vuelta_mmap_shared_memory);
  return direccion_vuelta_mmap_shared_memory;

};  // Fin de mmap
 

extern int munmap(void *addr, size_t len)
{
  printf ("munmap\n");

  free (addr);
  return 1;

};  // Fin de munmap


extern int shm_open (const char *name, int oflag) //, mode_t mode)
{
  printf ("shm_open\n");
  return 1;
}; // Fin de shm_open


extern int shm_unlink (const char *name)
{
  printf ("shm_unlink\n");

  return 1;
}
