/*----------------------------------------------------------------------------
 *-------------------------         R T - E P         ------------------------
 *----------------------------------------------------------------------------
 *                                                             {LINUX_VERSION}
 *
 *                           'p r o t _ t y p e s . c'
 *
 *                                     C
 *
 *                                               
 * File 'prot_types.c'                                                By Chema.
 *                                                          Jose Maria Martinez
 *                                                         <martinjm@unican.es>
 *
 * Body functions of prot_types.h.
 *
 *
 *---------------------------------------------------------------------------*/
 /*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 */



#include "prot_types.h"

/* we will use this function in order to compare addresses it return 1 if equal and 0 if not..*/
/* it's much faster than memcmp*/

int addrcmp(unsigned char *addr1, unsigned char *addr2, const int len){

  int i;
  for(i=0;i<len;i++){
    if(addr1[i]==addr2[i]){
      if(i==len-1)
	return TRUE;
    } else
      return FALSE;
  }// en for.
  return FALSE;
}// end function addrcmp


int addrcpy(unsigned char *addr1, unsigned char *addr2, const int len){

  int i;
  for(i=0;i<len;i++){
    addr1[i]=addr2[i];
  }

  return 0;

}// en function addrcpy


